Index: LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 3940)
@@ -1,4 +1,4 @@
 !
-! $Id: phys_output_write_mod.F90 3692 2020-06-02 14:57:54Z oboucher $
+! $Id: phys_output_write_mod.F90 3900 2021-05-17 13:35:58Z evignon $
 !
 MODULE phys_output_write_mod
@@ -38,4 +38,7 @@
          o_t2m, o_t2m_min, o_t2m_max, &
          o_t2m_min_mon, o_t2m_max_mon, &
+         o_nt2mout, o_nt2moutfg, &
+         o_nq2mout, o_nq2moutfg, &
+         o_nu2mout, o_nu2moutfg, &
          o_q2m, o_ustar, o_u10m, o_v10m, &
          o_wind10m, o_wind10max, o_wind100m, o_gusts, o_sicf, &
@@ -45,5 +48,5 @@
          o_snow, o_msnow, o_fsnow, o_evap, o_ep,o_epmax_diag, & ! epmax_cape
          o_tops, o_tops0, o_topl, o_topl0, &
-         o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, &
+         o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, o_fdiffSWdnSFC, &
          o_SWdnTOAclr, o_nettop, o_SWup200, &
          o_SWup200clr, o_SWdn200, o_SWdn200clr, &
@@ -84,5 +87,5 @@
          o_dtvdf_x    , o_dtvdf_w    , o_dqvdf_x    , o_dqvdf_w    , &
          o_sens_x     , o_sens_w     , o_flat_x     , o_flat_w     , &
-         o_delta_tsurf, &
+         o_delta_tsurf, o_delta_tsurf_srf, &
          o_cdragh_x   , o_cdragh_w   , o_cdragm_x   , o_cdragm_w   , &
          o_kh         , o_kh_x       , o_kh_w       , &
@@ -133,8 +136,8 @@
          o_vitu, o_vitv, o_vitw, o_pres, o_paprs, &
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
-         o_rnebls, o_rneblsvol, o_rhum, o_ozone, o_ozone_light, &
+         o_rnebls, o_rneblsvol, o_rhum, o_rhl, o_rhi, o_ozone, o_ozone_light, &
          o_duphy, o_dtphy, o_dqphy, o_dqphy2d, o_dqlphy, o_dqlphy2d, &
          o_dqsphy, o_dqsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
-         o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, &
+         o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, o_tke_dissip, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
          o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
@@ -206,6 +209,9 @@
          o_col_O3_strato, o_col_O3_tropo,                 & 
 !--interactive CO2
-         o_flx_co2_ocean, o_flx_co2_land, o_flx_co2_ff, o_flx_co2_bb
-
+         o_flx_co2_ocean, o_flx_co2_ocean_cor, &
+         o_flx_co2_land, o_flx_co2_land_cor, & 
+         o_flx_co2_ff, o_flx_co2_bb, & 
+         o_delta_sst, o_delta_sal, o_ds_ns, o_dt_ns, o_dter, o_dser, o_tkt, &
+         o_tks, o_taur, o_sss
 
 #ifdef CPP_StratAer
@@ -230,5 +236,5 @@
          qsol, z0m, z0h, fevap, agesno, &
          nday_rain, rain_con, snow_con, &
-         topsw, toplw, toplw0, swup, swdn, &
+         topsw, toplw, toplw0, swup, swdn, solswfdiff, &
          topsw0, swupc0, swdnc0, swup0, swdn0, SWup200, SWup200clr, &
          SWdn200, SWdn200clr, LWup200, LWup200clr, &
@@ -252,14 +258,14 @@
          T2sumSTD, nlevSTD, du_gwd_rando, du_gwd_front, &
          ulevSTD, vlevSTD, wlevSTD, philevSTD, qlevSTD, tlevSTD, &
-         rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, &
+         rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, vphiSTD, &
+         wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
 #ifdef ISO
         xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
 #endif
-         vphiSTD, wTSTD, u2STD, v2STD, T2STD, missing_val_nf90
+         dt_ns, delta_sst
 
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
-         zt2m_cor,zq2m_cor,zu10m_cor,zv10m_cor, zrh2m_cor, zqsat2m_cor, &
-         t2m_min_mon, t2m_max_mon, evap, &
-         l_mixmin,l_mix, &
+         zn2mout, t2m_min_mon, t2m_max_mon, evap, &
+         l_mixmin,l_mix, tke_dissip, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
          rain_lsc, rain_num, snow_lsc, bils, sens, fder, &
@@ -268,8 +274,8 @@
          sissnow, runoff, albsol3_lic, evap_pot, &
          t2m, fluxt, fluxlat, fsollw, fsolsw, &
-         wfbils, wfbilo, wfevap, wfrain, wfsnow, & 
+         wfbils, wfbilo, wfevap, wfrain, wfsnow, &
          cdragm, cdragh, cldl, cldm, &
-         cldh, cldt, JrNt, cldljn, cldmjn, cldhjn, &
-         cldtjn, cldq, flwp, fiwp, ue, ve, uq, vq, &
+         cldh, cldt, JrNt,   & ! only output names: cldljn,cldmjn,cldhjn,cldtjn
+         cldq, flwp, fiwp, ue, ve, uq, vq, &
          uwat, vwat, &
          plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw, &
@@ -307,5 +313,5 @@
          ql_seri, qs_seri, tr_seri, &
          zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, rneblsvol, zx_rh, d_t_dyn,  & 
+         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, d_t_dyn,  & 
          d_q_dyn,  d_ql_dyn, d_qs_dyn, &
          d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, &
@@ -349,4 +355,5 @@
 
     USE carbon_cycle_mod, ONLY: fco2_ff, fco2_bb, fco2_land, fco2_ocean
+    USE carbon_cycle_mod, ONLY: fco2_ocean_cor, fco2_land_cor
 
     USE phys_output_var_mod, ONLY: vars_defined, snow_o, zfra_o, bils_diss, &
@@ -370,5 +377,5 @@
          alt_tropo, &
 !Ionela
-         ok_4xCO2atm
+         ok_4xCO2atm, dter, dser, tkt, tks, taur, sss
 
     USE ocean_slab_mod, ONLY: nslay, tslab, slab_bilg, tice, seaice, &
@@ -383,5 +390,5 @@
 #endif
     USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
-    USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, ok_snow
+    USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
     USE aero_mod, ONLY: naero_tot, id_STRAT_phy
     USE ioipsl, ONLY: histend, histsync
@@ -402,4 +409,5 @@
 #endif
     USE tracinca_mod, ONLY: config_inca
+    use config_ocean_skin_m, only: activate_ocean_skin
 
     USE vertical_layers_mod, ONLY: presnivs
@@ -471,4 +479,6 @@
     REAL,DIMENSION(klon)      :: zrho, zt
 
+    INTEGER :: nqup
+
     ! On calcul le nouveau tau:
     itau_w = itau_phy + itap 
@@ -484,4 +494,8 @@
 #ifdef CPP_XIOS
     CALL wxios_set_context
+#endif
+
+#ifndef CPP_XIOS
+    missing_val=missing_val_nf90
 #endif
 
@@ -702,7 +716,7 @@
        CALL histwrite_phy(o_slp, slp)
        CALL histwrite_phy(o_tsol, zxtsol)
-       CALL histwrite_phy(o_t2m, zt2m_cor)
-       CALL histwrite_phy(o_t2m_min, zt2m_cor)
-       CALL histwrite_phy(o_t2m_max, zt2m_cor)
+       CALL histwrite_phy(o_t2m, zt2m)
+       CALL histwrite_phy(o_t2m_min, zt2m)
+       CALL histwrite_phy(o_t2m_max, zt2m)
        CALL histwrite_phy(o_t2m_max_mon, t2m_max_mon)
        CALL histwrite_phy(o_t2m_min_mon, t2m_min_mon)
@@ -710,5 +724,47 @@
        IF (vars_defined) THEN
           DO i=1, klon
-             zx_tmp_fi2d(i)=SQRT(zu10m_cor(i)*zu10m_cor(i)+zv10m_cor(i)*zv10m_cor(i))
+             zx_tmp_fi2d(i)=real(zn2mout(i,1))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nt2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,2))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nt2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,3))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nq2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,4))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nq2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,5))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nu2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,6))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nu2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
           ENDDO
        ENDIF
@@ -717,5 +773,5 @@
        IF (vars_defined) THEN
           DO i=1, klon
-             zx_tmp_fi2d(i)=SQRT(zu10m_cor(i)*zu10m_cor(i)+zv10m_cor(i)*zv10m_cor(i))
+             zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
           ENDDO
        ENDIF
@@ -725,5 +781,4 @@
 
        IF (vars_defined) THEN
-          missing_val=missing_val_nf90
           DO k = 1, kmax_100m                                      !--we could stop much lower
             zrho(:) = pplay(:,k)/t_seri(:,k)/RD                    ! air density in kg/m3
@@ -759,6 +814,6 @@
                zx_tmp_fi2d(i)=1.0
              ELSE
-               zx_tmp_fi2d(i)= 1.059e-09*x**10. - 1.351e-07*x**9. + 7.478e-06*x**8. - 0.0002352*x**7. + 0.004627*x**6. & 
-                             - 0.05898*x**5. + 0.4893*x**4. - 2.59*x**3. + 8.339*x**2. - 14.69*x + 10.73
+               zx_tmp_fi2d(i)= 10.73 + x*(-14.69 + x*(8.339 + x*(-2.59 + x*(0.4893 + x*(-0.05898 + x*(0.004627 + & 
+                               x*(-0.0002352 + x*(7.478e-06 + x*(-1.351e-07 + x*(1.059e-09))))))))))
                zx_tmp_fi2d(i)=MIN(MAX(zx_tmp_fi2d(i),0.0),1.0)
              ENDIF
@@ -780,6 +835,6 @@
                zx_tmp_fi2d(i)=1.0
              ELSE
-               zx_tmp_fi2d(i)= 3.352e-10*x**10. - 4.959e-08*x**9. + 3.195e-06*x**8. - 0.0001175*x**7. + 0.002716*x**6. &
-                             - 0.04099*x**5. + 0.4065*x**4. - 2.601*x**3. + 10.25*x**2. - 22.39*x + 20.59
+               zx_tmp_fi2d(i)= 20.59 + x*(-22.39 + x*(10.25 + x*(-2.601 + x*(0.4065 + x*(-0.04099 + x*(0.002716 + & 
+                               x*(-0.0001175 + x*(3.195e-06 + x*(-4.959e-08 + x*(3.352e-10))))))))))
                zx_tmp_fi2d(i)=MIN(MAX(zx_tmp_fi2d(i),0.0),1.0)
              ENDIF
@@ -797,8 +852,10 @@
        ENDIF
        CALL histwrite_phy(o_sicf, zx_tmp_fi2d)
-       CALL histwrite_phy(o_q2m, zq2m_cor)
-       CALL histwrite_phy(o_ustar, zustar)
-       CALL histwrite_phy(o_u10m, zu10m_cor)
-       CALL histwrite_phy(o_v10m, zv10m_cor)
+       CALL histwrite_phy(o_q2m, zq2m)
+       IF (vars_defined) zx_tmp_fi2d = zustar
+       CALL histwrite_phy(o_ustar, zx_tmp_fi2d)
+       CALL histwrite_phy(o_u10m, zu10m)
+       CALL histwrite_phy(o_v10m, zv10m)
+
 
        IF (vars_defined) THEN
@@ -961,4 +1018,6 @@
        ENDIF
        CALL histwrite_phy(o_SWdnSFCcleanclr, zx_tmp_fi2d)
+
+       CALL histwrite_phy(o_fdiffSWdnSFC, solswfdiff)
 
        IF (vars_defined) THEN
@@ -1022,13 +1081,14 @@
        CALL histwrite_phy(o_tauy, zx_tmp_fi2d)
 
-       IF (ok_snow) THEN
-          CALL histwrite_phy(o_snowsrf, snow_o)
-          CALL histwrite_phy(o_qsnow, qsnow)
-          CALL histwrite_phy(o_snowhgt,snowhgt)
-          CALL histwrite_phy(o_toice,to_ice)
-          CALL histwrite_phy(o_sissnow,sissnow)
-          CALL histwrite_phy(o_runoff,runoff)
-          CALL histwrite_phy(o_albslw3,albsol3_lic)
-       ENDIF
+       ! Etienne: test sorties pour compil sur JZ
+!       IF (landice_opt .GE. 1) THEN
+!          CALL histwrite_phy(o_snowsrf, snow_o)
+!          CALL histwrite_phy(o_qsnow, qsnow)
+!          CALL histwrite_phy(o_snowhgt,snowhgt)
+!          CALL histwrite_phy(o_toice,to_ice)
+!          CALL histwrite_phy(o_sissnow,sissnow)
+!          CALL histwrite_phy(o_runoff,runoff)
+!          CALL histwrite_phy(o_albslw3,albsol3_lic)
+!       ENDIF
 
        DO nsrf = 1, nbsrf
@@ -1080,4 +1140,6 @@
              CALL histwrite_phy(o_l_mixmin(nsrf),  l_mixmin(:,1:klev,nsrf))
              CALL histwrite_phy(o_tke_max_srf(nsrf),  pbl_tke(:,1:klev,nsrf))
+
+                         
           ENDIF
 !jyg<
@@ -1090,6 +1152,20 @@
 !            ENDIF
 
-
        ENDDO
+       
+                
+        IF (iflag_pbl > 1) THEN
+          zx_tmp_fi3d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                DO k=1,klev
+                   zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k) &
+                        +pctsrf(:,nsrf)*tke_dissip(:,k,nsrf)
+                ENDDO
+             ENDDO
+          ENDIF
+          
+          CALL histwrite_phy(o_tke_dissip, zx_tmp_fi3d)    
+       ENDIF
 
        IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_liq_o(1 : klon, 1)
@@ -1215,5 +1291,4 @@
        ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
        ! Champs interpolles sur des niveaux de pression
-       missing_val=missing_val_nf90
        DO iff=1, nfiles
           ll=0
@@ -1307,9 +1382,18 @@
 !
                CALL histwrite_phy(o_dqvdf_w    ,zx_tmp_fi3d) 
-               CALL histwrite_phy(o_sens_x     ,sens_x     ) 
-               CALL histwrite_phy(o_sens_w     ,sens_w     ) 
+       IF (vars_defined)  zx_tmp_fi2d(1:klon)=-1*sens_x(1:klon)
+               CALL histwrite_phy(o_sens_x     ,zx_tmp_fi2d) 
+       IF (vars_defined)  zx_tmp_fi2d(1:klon)=-1*sens_w(1:klon)
+               CALL histwrite_phy(o_sens_w     ,zx_tmp_fi2d) 
                CALL histwrite_phy(o_flat_x     ,zxfluxlat_x) 
                CALL histwrite_phy(o_flat_w     ,zxfluxlat_w) 
-               CALL histwrite_phy(o_delta_tsurf,delta_tsurf) 
+          zx_tmp_fi2d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:) &
+                        +pctsrf(:,nsrf)*delta_tsurf(:,nsrf)
+             ENDDO
+          ENDIF
+               CALL histwrite_phy(o_delta_tsurf,zx_tmp_fi2d) 
                CALL histwrite_phy(o_cdragh_x   ,cdragh_x   ) 
                CALL histwrite_phy(o_cdragh_w   ,cdragh_w   ) 
@@ -1419,5 +1503,9 @@
        IF (vars_defined) THEN
           DO i=1, klon
-             zx_tmp_fi2d(i)=MIN(100.,rh2m(i)*100.)
+             IF (zt2m(i).LE.273.15) then
+                zx_tmp_fi2d(i)=MAX(0.,rh2m(i)*100.)
+             ELSE
+                zx_tmp_fi2d(i)=MAX(0.,MIN(100.,rh2m(i)*100.))
+             ENDIF
           ENDDO
        ENDIF
@@ -1438,5 +1526,5 @@
 !       CALL histwrite_phy(o_rh2m_max, zx_tmp_fi2d)
 
-       CALL histwrite_phy(o_qsat2m, zqsat2m_cor)
+       CALL histwrite_phy(o_qsat2m, qsat2m)
        CALL histwrite_phy(o_tpot, tpot)
        CALL histwrite_phy(o_tpote, tpote)
@@ -1717,4 +1805,11 @@
        CALL histwrite_phy(o_rnebjn, zx_tmp_fi3d)
        CALL histwrite_phy(o_rhum, zx_rh)
+       IF (iflag_ice_thermo .GT. 0) THEN
+          IF (vars_defined) zx_tmp_fi3d = zx_rhl * 100.
+          CALL histwrite_phy(o_rhl, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d = zx_rhi * 100.
+          CALL histwrite_phy(o_rhi, zx_tmp_fi3d)
+       ENDIF
+
        
        IF (vars_defined) zx_tmp_fi3d = wo(:, :, 1) * dobson_u * 1e3 / zmasse / rmo3 * rmd
@@ -1775,6 +1870,6 @@
           ENDIF
           CALL histwrite_phy(o_tke, zx_tmp_fi3d)
-
-          CALL histwrite_phy(o_tke_max, zx_tmp_fi3d)
+          CALL histwrite_phy(o_tke_max, zx_tmp_fi3d)  
+
        ENDIF
 
@@ -2188,5 +2283,4 @@
           CALL histwrite_phy(o_rldcs4co2, lwdn0p)
        ENDIF !ok_4xCO2atm
-        write(*,*) 'phys_output_write 2188'
 !!!!!!!!!!!! Sorties niveaux de pression NMC !!!!!!!!!!!!!!!!!!!!
 #ifdef CPP_IOIPSL
@@ -2195,5 +2289,4 @@
        ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
        ! Champs interpolles sur des niveaux de pression
-       missing_val=missing_val_nf90
        DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
 
@@ -2329,5 +2422,4 @@
   ENDIF
 #endif
-        write(*,*) 'phys_output_write 2331'
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        IF (iflag_phytrac == 1 ) then
@@ -2389,10 +2481,51 @@
            CALL histwrite_phy(o_flx_co2_land,  fco2_land)
            CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
+           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
+           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
            CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
            CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
          ENDIF !--type_trac co2i
 
+         IF (type_trac == 'inco') THEN
+           nqup = nqo+1
+           DO iq=nqo+1, nqup
+             !--3D fields
+             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
+             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
+             CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
+             CALL histwrite_phy(o_dtr_con(iq-nqo),d_tr_cv(:,:,iq-nqo))
+             !--2D fields
+             !--CO2 burden
+             zx_tmp_fi2d=0.
+             IF (vars_defined) THEN
+                DO k=1,klev
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+                ENDDO
+             ENDIF
+             CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+           ENDDO !--iq
+           !--CO2 net fluxes
+           CALL histwrite_phy(o_flx_co2_land,  fco2_land)
+           CALL histwrite_phy(o_flx_co2_ocean, fco2_ocean)
+           CALL histwrite_phy(o_flx_co2_ocean_cor, fco2_ocean_cor)
+           CALL histwrite_phy(o_flx_co2_land_cor, fco2_land_cor)
+           CALL histwrite_phy(o_flx_co2_ff,    fco2_ff)
+           CALL histwrite_phy(o_flx_co2_bb,    fco2_bb)
+         ENDIF !--type_trac inco
+
        ENDIF   !(iflag_phytrac==1)
 
+       if (activate_ocean_skin >= 1) then
+          CALL histwrite_phy(o_delta_sst, delta_sst)
+          CALL histwrite_phy(o_delta_sal, delta_sal)
+          CALL histwrite_phy(o_ds_ns, ds_ns)
+          CALL histwrite_phy(o_dt_ns, dt_ns)
+          CALL histwrite_phy(o_dter, dter)
+          CALL histwrite_phy(o_dser, dser)
+          CALL histwrite_phy(o_tkt, tkt)
+          CALL histwrite_phy(o_tks, tks)
+          CALL histwrite_phy(o_taur, taur)
+          CALL histwrite_phy(o_sss, sss)
+       end if
 
 #ifdef ISO
Index: LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90	(revision 3940)
@@ -1,4 +1,4 @@
 !
-! $Id: phys_state_var_mod.F90 3496 2019-05-10 10:17:35Z jyg $
+! $Id: phys_state_var_mod.F90 3888 2021-05-05 10:50:37Z jyg $
 !
       MODULE phys_state_var_mod
@@ -32,4 +32,6 @@
       REAL, ALLOCATABLE, SAVE :: ftsol(:,:)
 !$OMP THREADPRIVATE(ftsol)
+      REAL, ALLOCATABLE, SAVE :: beta_aridity(:,:)
+!$OMP THREADPRIVATE(beta_aridity)
       REAL,ALLOCATABLE,SAVE :: qsol(:),fevap(:,:),z0m(:,:),z0h(:,:),agesno(:,:)
 !$OMP THREADPRIVATE(qsol,fevap,z0m,z0h,agesno)
@@ -47,5 +49,5 @@
 !albedo SB >>>
       REAL, ALLOCATABLE, SAVE :: falb_dif(:,:,:), falb_dir(:,:,:)
-      real, allocatable, save :: chl_con(:)
+      REAL, ALLOCATABLE, SAVE :: chl_con(:)
 !$OMP THREADPRIVATE(falb_dir,falb_dif,chl_con)
 !albedo SB <<<
@@ -106,8 +108,4 @@
       REAL, ALLOCATABLE, SAVE :: coefm(:,:,:) ! Kz momentum
 !$OMP THREADPRIVATE(pbl_tke, coefh,coefm)
-!nrlmd<
-      REAL, ALLOCATABLE, SAVE :: delta_tsurf(:,:) ! Surface temperature difference inside-outside cold pool
-!$OMP THREADPRIVATE(delta_tsurf)
-!>nrlmd
       REAL, ALLOCATABLE, SAVE :: zmax0(:), f0(:) ! 
 !$OMP THREADPRIVATE(zmax0,f0)
@@ -294,4 +292,8 @@
       REAL,ALLOCATABLE,SAVE :: wake_delta_pbl_TKE(:,:,:)
 !$OMP THREADPRIVATE(wake_delta_pbl_TKE)
+!nrlmd<
+      REAL, ALLOCATABLE, SAVE :: delta_tsurf(:,:) ! Surface temperature difference inside-outside cold pool
+!$OMP THREADPRIVATE(delta_tsurf)
+!>nrlmd
 !>jyg
 !
@@ -442,8 +444,9 @@
 !$OMP THREADPRIVATE(ccm)
 
-!!! nrlmd le 10/04/2012
       REAL,SAVE,ALLOCATABLE :: ale_bl_trig(:)
 !$OMP THREADPRIVATE(ale_bl_trig)
-!!! fin nrlmd le 10/04/2012
+
+      REAL,SAVE,ALLOCATABLE :: ratqs_inter(:,:)
+!$OMP THREADPRIVATE(ratqs_inter)
 
 #ifdef ISO
@@ -462,5 +465,26 @@
 !$OMP THREADPRIVATE(is_initialized)    
 
-CONTAINS
+      ! Ocean-atmosphere interface:
+
+      REAL, ALLOCATABLE, SAVE:: ds_ns(:) ! (klon)
+      ! "delta salinity near surface". Salinity variation in the
+      ! near-surface turbulent layer. That is subskin salinity minus
+      ! foundation salinity. In ppt.
+
+      REAL, ALLOCATABLE, SAVE:: dt_ns(:) ! (klon)
+      ! "delta temperature near surface". Temperature variation in the
+      ! near-surface turbulent layer. That is subskin temperature
+      ! minus foundation temperature. (Can be negative.) In K.
+      
+      REAL, ALLOCATABLE, SAVE:: delta_sst(:) ! (klon)
+      ! Ocean-air interface temperature minus bulk SST, in
+      ! K. Allocated and defined only if activate_ocean_skin >= 1.
+
+      REAL, ALLOCATABLE, SAVE:: delta_sal(:) ! (klon)
+      ! Ocean-air interface salinity minus bulk salinity, in ppt
+      
+      !$OMP THREADPRIVATE(delta_sal, ds_ns, dt_ns, delta_sst)
+
+    CONTAINS
 
 !======================================================================
@@ -473,4 +497,5 @@
 #endif
 USE indice_sol_mod
+use config_ocean_skin_m, only: activate_ocean_skin
 IMPLICIT NONE
 
@@ -485,8 +510,10 @@
 include "clesphys.h"
 
+      print*, 'is_initialized', is_initialized
       IF (is_initialized) RETURN
       is_initialized=.TRUE.
       ALLOCATE(pctsrf(klon,nbsrf))
       ALLOCATE(ftsol(klon,nbsrf))
+      ALLOCATE(beta_aridity(klon,nbsrf))
       ALLOCATE(qsol(klon),fevap(klon,nbsrf))
       ALLOCATE(z0m(klon,nbsrf+1),z0h(klon,nbsrf+1),agesno(klon,nbsrf))
@@ -496,5 +523,7 @@
       ALLOCATE(falb2(klon,nbsrf))
 !albedo SB >>> 
+      print*, 'allocate falb'
       ALLOCATE(falb_dir(klon,nsw,nbsrf),falb_dif(klon,nsw,nbsrf))
+      print*, 'allocate falb good', falb_dir(1,1,1)
       ALLOCATE(chl_con(klon))
 !albedo SB <<<
@@ -675,9 +704,9 @@
 #endif      
 #endif
-!!! nrlmd le 10/04/2012
+
       ALLOCATE(ale_bl_trig(klon))
-!!! fin nrlmd le 10/04/2012
+      ALLOCATE(ratqs_inter(klon,klev))
       IF (ok_gwd_rando) THEN
-        allocate(du_gwd_rando(klon, klev))
+        ALLOCATE(du_gwd_rando(klon, klev))
         du_gwd_rando(:,:)=0.
       ENDIF
@@ -686,147 +715,155 @@
         du_gwd_front(:,:) = 0 !ym missing init   
       ENDIF
-END SUBROUTINE phys_state_var_init
+      if (activate_ocean_skin >= 1) ALLOCATE(delta_sal(klon), ds_ns(klon), &
+           dt_ns(klon), delta_sst(klon))
+
+    END SUBROUTINE phys_state_var_init
 
 !======================================================================
-SUBROUTINE phys_state_var_end
+    SUBROUTINE phys_state_var_end
+      ! Useful only for lmdz1d.
 !USE dimphy
 USE indice_sol_mod
+use config_ocean_skin_m, only: activate_ocean_skin
 IMPLICIT NONE
 include "clesphys.h"
 
-      deallocate(pctsrf, ftsol, falb1, falb2)
-      deallocate(qsol,fevap,z0m,z0h,agesno)
+      DEALLOCATE(pctsrf, ftsol, falb1, falb2)
+      DEALLOCATE(beta_aridity)
+      DEALLOCATE(qsol,fevap,z0m,z0h,agesno)
 !FC
-      deallocate(treedrg)
-      deallocate(rain_fall, snow_fall, solsw, solswfdiff, sollw, radsol, swradcorr)
-      deallocate(zmea, zstd, zsig, zgam)
-      deallocate(zthe, zpic, zval)
-      deallocate(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
-      deallocate(qs_ancien, ql_ancien)
-      deallocate(prw_ancien, prlw_ancien, prsw_ancien)
-      deallocate(qtc_cv,sigt_cv)
-      deallocate(u_ancien, v_ancien)
-      deallocate(tr_ancien)                           !RomP
-      deallocate(ratqs, pbl_tke,coefh,coefm)
+      DEALLOCATE(treedrg)
+      DEALLOCATE(rain_fall, snow_fall, solsw, solswfdiff, sollw, radsol, swradcorr)
+      DEALLOCATE(zmea, zstd, zsig, zgam)
+      DEALLOCATE(zthe, zpic, zval)
+      DEALLOCATE(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
+      DEALLOCATE(qs_ancien, ql_ancien)
+      DEALLOCATE(prw_ancien, prlw_ancien, prsw_ancien)
+      DEALLOCATE(qtc_cv,sigt_cv)
+      DEALLOCATE(u_ancien, v_ancien)
+      DEALLOCATE(tr_ancien)                           !RomP
+      DEALLOCATE(ratqs, pbl_tke,coefh,coefm)
+      DEALLOCATE(zmax0, f0)
+      DEALLOCATE(sig1, w01)
+      DEALLOCATE(entr_therm, fm_therm)
+      DEALLOCATE(detr_therm)
+      DEALLOCATE(clwcon0th, rnebcon0th)
+! radiation outputs
+      DEALLOCATE(swdnc0, swdn0, swdn)
+      DEALLOCATE(swupc0, swup0, swup)
+      DEALLOCATE(lwdnc0, lwdn0, lwdn)
+      DEALLOCATE(lwupc0, lwup0, lwup)
+      DEALLOCATE(SWdn200clr, SWdn200)
+      DEALLOCATE(SWup200clr, SWup200)
+      DEALLOCATE(LWdn200clr, LWdn200)
+      DEALLOCATE(LWup200clr, LWup200)
+      DEALLOCATE(LWdnTOA, LWdnTOAclr)
+! pressure level
+      DEALLOCATE(tsumSTD)
+      DEALLOCATE(usumSTD, vsumSTD)
+      DEALLOCATE(wsumSTD, phisumSTD)
+      DEALLOCATE(tnondef)
+      DEALLOCATE(qsumSTD, rhsumSTD)
+      DEALLOCATE(uvsumSTD)
+      DEALLOCATE(vqsumSTD)
+      DEALLOCATE(vTsumSTD)
+      DEALLOCATE(wqsumSTD)
+      DEALLOCATE(vphisumSTD)
+      DEALLOCATE(wTsumSTD)
+      DEALLOCATE(u2sumSTD)
+      DEALLOCATE(v2sumSTD)
+      DEALLOCATE(T2sumSTD)
+      DEALLOCATE(O3sumSTD)
+      DEALLOCATE(O3daysumSTD)
+!IM beg
+      DEALLOCATE(wlevSTD,ulevSTD,vlevSTD,tlevSTD,qlevSTD,rhlevSTD,philevSTD)
+      DEALLOCATE(uvSTD,vqSTD,vTSTD,wqSTD,vphiSTD,wTSTD,u2STD,v2STD,T2STD,O3STD,O3daySTD)
+!IM end
+      DEALLOCATE(seed_old)
+      DEALLOCATE(zuthe, zvthe)
+      DEALLOCATE(alb_neig)
+      DEALLOCATE(ema_cbmf)
+      DEALLOCATE(ema_pcb, ema_pct)
+      DEALLOCATE(Mipsh, Ma, qcondc)
+      DEALLOCATE(wd, sigd)
+      DEALLOCATE(cin, ALE, ALP)
+      DEALLOCATE(ftd, fqd)
+      DEALLOCATE(Ale_bl, Alp_bl)
+      DEALLOCATE(ale_wake)
+      DEALLOCATE(ale_bl_stat)
+      DEALLOCATE(lalim_conv, wght_th)
+      DEALLOCATE(wake_deltat, wake_deltaq)
+      DEALLOCATE(wake_s, awake_dens, wake_dens)
+      DEALLOCATE(wake_Cstar, wake_pe, wake_fip)
+!jyg<
+      DEALLOCATE(wake_delta_pbl_TKE)
 !nrlmd<
-      deallocate(delta_tsurf)
+      DEALLOCATE(delta_tsurf)
 !>nrlmd
-      deallocate(zmax0, f0)
-      deallocate(sig1, w01)
-      deallocate(entr_therm, fm_therm)
-      deallocate(detr_therm)
-      deallocate(clwcon0th, rnebcon0th)
-! radiation outputs
-      deallocate(swdnc0, swdn0, swdn)
-      deallocate(swupc0, swup0, swup)
-      deallocate(lwdnc0, lwdn0, lwdn)
-      deallocate(lwupc0, lwup0, lwup)
-      deallocate(SWdn200clr, SWdn200)
-      deallocate(SWup200clr, SWup200)
-      deallocate(LWdn200clr, LWdn200)
-      deallocate(LWup200clr, LWup200)
-      deallocate(LWdnTOA, LWdnTOAclr)
-! pressure level
-      deallocate(tsumSTD)
-      deallocate(usumSTD, vsumSTD)
-      deallocate(wsumSTD, phisumSTD)
-      deallocate(tnondef)
-      deallocate(qsumSTD, rhsumSTD)
-      deallocate(uvsumSTD)
-      deallocate(vqsumSTD)
-      deallocate(vTsumSTD)
-      deallocate(wqsumSTD)
-      deallocate(vphisumSTD)
-      deallocate(wTsumSTD)
-      deallocate(u2sumSTD)
-      deallocate(v2sumSTD)
-      deallocate(T2sumSTD)
-      deallocate(O3sumSTD)
-      deallocate(O3daysumSTD)
-!IM beg
-      deallocate(wlevSTD,ulevSTD,vlevSTD,tlevSTD,qlevSTD,rhlevSTD,philevSTD)
-      deallocate(uvSTD,vqSTD,vTSTD,wqSTD,vphiSTD,wTSTD,u2STD,v2STD,T2STD,O3STD,O3daySTD)
-!IM end
-      deallocate(seed_old)
-      deallocate(zuthe, zvthe)
-      deallocate(alb_neig)
-      deallocate(ema_cbmf)
-      deallocate(ema_pcb, ema_pct)
-      deallocate(Mipsh, Ma, qcondc)
-      deallocate(wd, sigd)
-      deallocate(cin, ALE, ALP)
-      deallocate(ftd, fqd)
-      deallocate(Ale_bl, Alp_bl)
-      deallocate(ale_wake)
-      deallocate(ale_bl_stat)
-      deallocate(lalim_conv, wght_th)
-      deallocate(wake_deltat, wake_deltaq)
-      deallocate(wake_s, awake_dens, wake_dens)
-      deallocate(wake_Cstar, wake_pe, wake_fip)
-!jyg<
-      deallocate(wake_delta_pbl_TKE)
 !>jyg
-      deallocate(pfrac_impa, pfrac_nucl)
-      deallocate(pfrac_1nucl)
-      deallocate(total_rain, nday_rain)
-      deallocate(paire_ter)
-      deallocate(albsol1, albsol2)
+      DEALLOCATE(pfrac_impa, pfrac_nucl)
+      DEALLOCATE(pfrac_1nucl)
+      DEALLOCATE(total_rain, nday_rain)
+      DEALLOCATE(paire_ter)
+      DEALLOCATE(albsol1, albsol2)
 !albedo SB >>>
-      deallocate(albsol_dir,albsol_dif,falb_dir,falb_dif,chl_con)
+      DEALLOCATE(albsol_dir,albsol_dif,falb_dir,falb_dif,chl_con)
 !albedo SB <<<
-      deallocate(wo)
-      deallocate(clwcon0,rnebcon0)
-      deallocate(heat, heat0) 
-      deallocate(cool, cool0)
-      deallocate(heat_volc, cool_volc) 
-      deallocate(topsw, toplw)
-      deallocate(sollwdown, sollwdownclr)
-      deallocate(gustiness)
-      deallocate(toplwdown, toplwdownclr)
-      deallocate(topsw0,toplw0,solsw0,sollw0)
-      deallocate(albpla)
+      DEALLOCATE(wo)
+      DEALLOCATE(clwcon0,rnebcon0)
+      DEALLOCATE(heat, heat0) 
+      DEALLOCATE(cool, cool0)
+      DEALLOCATE(heat_volc, cool_volc) 
+      DEALLOCATE(topsw, toplw)
+      DEALLOCATE(sollwdown, sollwdownclr)
+      DEALLOCATE(gustiness)
+      DEALLOCATE(toplwdown, toplwdownclr)
+      DEALLOCATE(topsw0,toplw0,solsw0,sollw0)
+      DEALLOCATE(albpla)
 !IM ajout variables CFMIP2/CMIP5
-      deallocate(heatp, coolp)
-      deallocate(heat0p, cool0p)
-      deallocate(radsolp, topswp, toplwp)
-      deallocate(albplap)
-      deallocate(solswp, solswfdiffp, sollwp)
-      deallocate(sollwdownp)
-      deallocate(topsw0p,toplw0p)
-      deallocate(solsw0p,sollw0p)
-      deallocate(lwdnc0p, lwdn0p, lwdnp)
-      deallocate(lwupc0p, lwup0p, lwupp)
-      deallocate(swdnc0p, swdn0p, swdnp)
-      deallocate(swupc0p, swup0p, swupp)
-      deallocate(cape)
-      deallocate(pbase,bbase)
-      deallocate(zqasc)
-      deallocate(ibas_con, itop_con)
-      deallocate(rain_con, snow_con)
-      deallocate(rlonPOS)
-      deallocate(newsst)
-      deallocate(ustar,u10m, v10m,wstar)
-      deallocate(topswad, solswad)
-      deallocate(topswai, solswai)
-      deallocate(tau_aero,piz_aero,cg_aero)
-      deallocate(tau_aero_sw_rrtm,piz_aero_sw_rrtm,cg_aero_sw_rrtm)
-      deallocate(tau_aero_lw_rrtm,piz_aero_lw_rrtm,cg_aero_lw_rrtm)
-      deallocate(ccm)
-      if (ok_gwd_rando) deallocate(du_gwd_rando)
-      if (.not. ok_hines .and. ok_gwd_rando) deallocate(du_gwd_front)
-       
-!!! nrlmd le 10/04/2012
-      deallocate(ale_bl_trig)
-!!! fin nrlmd le 10/04/2012
+      DEALLOCATE(heatp, coolp)
+      DEALLOCATE(heat0p, cool0p)
+      DEALLOCATE(radsolp, topswp, toplwp)
+      DEALLOCATE(albplap)
+      DEALLOCATE(solswp, solswfdiffp, sollwp)
+      DEALLOCATE(sollwdownp)
+      DEALLOCATE(topsw0p,toplw0p)
+      DEALLOCATE(solsw0p,sollw0p)
+      DEALLOCATE(lwdnc0p, lwdn0p, lwdnp)
+      DEALLOCATE(lwupc0p, lwup0p, lwupp)
+      DEALLOCATE(swdnc0p, swdn0p, swdnp)
+      DEALLOCATE(swupc0p, swup0p, swupp)
+      DEALLOCATE(cape)
+      DEALLOCATE(pbase,bbase)
+      DEALLOCATE(zqasc)
+      DEALLOCATE(ibas_con, itop_con)
+      DEALLOCATE(rain_con, snow_con)
+      DEALLOCATE(rlonPOS)
+      DEALLOCATE(newsst)
+      DEALLOCATE(ustar,u10m, v10m,wstar)
+      DEALLOCATE(topswad, solswad)
+      DEALLOCATE(topswai, solswai)
+      DEALLOCATE(tau_aero,piz_aero,cg_aero)
+      DEALLOCATE(tau_aero_sw_rrtm,piz_aero_sw_rrtm,cg_aero_sw_rrtm)
+      DEALLOCATE(tau_aero_lw_rrtm,piz_aero_lw_rrtm,cg_aero_lw_rrtm)
+      DEALLOCATE(ccm)
+      if (ok_gwd_rando) DEALLOCATE(du_gwd_rando)
+      if (.not. ok_hines .and. ok_gwd_rando) DEALLOCATE(du_gwd_front)
+      DEALLOCATE(ale_bl_trig)
+      DEALLOCATE(ratqs_inter)
+
+      if (activate_ocean_skin >= 1) deALLOCATE(delta_sal, ds_ns, dt_ns, &
+           delta_sst)
 
 #ifdef ISO    
-      deallocate(xtsol,fxtevap)  
-      deallocate(xt_ancien,xtl_ancien,xts_ancien, fxtd, wake_deltaxt)
-      deallocate(xtrain_fall, xtsnow_fall, xtrain_con, xtsnow_con)
+      DEALLOCATE(xtsol,fxtevap)  
+      DEALLOCATE(xt_ancien,xtl_ancien,xts_ancien, fxtd, wake_deltaxt)
+      DEALLOCATE(xtrain_fall, xtsnow_fall, xtrain_con, xtsnow_con)
 #ifdef ISOTRAC 
-      deallocate(bassin_map,boite_map) 
+      DEALLOCATE(bassin_map,boite_map) 
 #endif        
 #endif
       is_initialized=.FALSE.
+      
 END SUBROUTINE phys_state_var_end
 
